/* (C) Copyright 1984,85,86,87 Walter L. Peacock	All Rights Reserved	 */
/****************************************************************************
 *
 *   btopen.c	 --  CBTREE portable binary file open function
 *
 */

#include "cbtrdef.h"
#include "btfio.h"

#ifndef ERR
#define ERR -1
#endif

int bt_open(name, mode, prot)   /* open/create a file in binary mode */
char *name;   /* file name */
int	mode;   /* IMPORTANT: see btfio.h */
int	prot;   /* if O_NEW is specified, protection *MUST* be specified */
{

#if MW | DC | CI | EC

	if (mode & O_NEW)   /* if selected O_NEW */
	{
#if CI
		return (creat(name, O_RAW | mode & ~O_NEW));
#else
#if EC
		return (creat(name, prot));   /* MSDOS attribute */
#else
		return (creat(name));   /* default */
#endif	/* !EC */
#endif	/* !CI */
	}

	else if (mode & O_CREAT)   /* create file if it DOESN'T exist */
	{
		int fd;

		/* if file EXISTS */
		if ((fd = bt_open(name, mode & ~O_CREAT)) != ERR)
			return (fd);	/* return file descriptor */
		
#if CI
		return (creat(name, O_RAW | mode & ~O_NEW));
#else
#if EC
		return (creat(name, prot));   /* MSDOS attribute */
#else
		return (creat(name));   /* default */
#endif	/* !EC */
#endif	/* !CI */
	}

#endif	/* MW | DC | CI | EC */

	return (open(name, O_RAW | mode, prot));
}
